## libffado 2.1.0+svn2456

=== SConstruct ===
#! /usr/bin/python
# -*- coding: utf-8 -*-
#
# Copyright (C) 2007, 2008, 2010 Arnold Krille
# Copyright (C) 2007, 2008 Pieter Palmers
# Copyright (C) 2008, 2012 Jonathan Woithe
#
# This file is part of FFADO
# FFADO = Free Firewire (pro-)audio drivers for linux
#
# FFADO is based upon FreeBoB.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

FFADO_API_VERSION = "9"
FFADO_VERSION="2.1.9999"

from subprocess import Popen, PIPE
import os
import re
from string import Template
import imp
import distutils.sysconfig

if not os.path.isdir( "cache" ):
	os.makedirs( "cache" )

opts = Variables( "cache/options.cache" )

opts.AddVariables(
    BoolVariable( "DEBUG", """\
Toggle debug-build. DEBUG means \"-g -Wall\" and more, otherwise we will use
  \"-O2\" to optimize.""", True ),
    BoolVariable( "PROFILE", "Build with symbols and other profiling info", False ),
    PathVariable( "PREFIX", "The prefix where ffado will be installed to.", "/usr/local", PathVariable.PathAccept ),
    PathVariable( "BINDIR", "Overwrite the directory where apps are installed to.", "$PREFIX/bin", PathVariable.PathAccept ),
    PathVariable( "LIBDIR", "Overwrite the directory where libs are installed to.", "$PREFIX/lib", PathVariable.PathAccept ),
    PathVariable( "INCLUDEDIR", "Overwrite the directory where headers are installed to.", "$PREFIX/include", PathVariable.PathAccept ),
    PathVariable( "SHAREDIR", "Overwrite the directory where misc shared files are installed to.", "$PREFIX/share/libffado", PathVariable.PathAccept ),
    PathVariable( "MANDIR", "Overwrite the directory where manpages are installed", "$PREFIX/man", PathVariable.PathAccept ),
    PathVariable( "PYPKGDIR", "The directory where the python modules get installed.",
        distutils.sysconfig.get_python_lib( prefix="$PREFIX" ), PathVariable.PathAccept ),
    PathVariable( "UDEVDIR", "Overwrite the directory where udev rules are installed to.", "/lib/udev/rules.d/", PathVariable.PathAccept ),
    BoolVariable( "ENABLE_BEBOB", "Enable/Disable support for the BeBoB platform.", True ),
    BoolVariable( "ENABLE_FIREWORKS", "Enable/Disable support for the ECHO Audio FireWorks platform.", True ),
    BoolVariable( "ENABLE_OXFORD", "Enable/Disable support for the Oxford Semiconductor FW platform.", True ),
    BoolVariable( "ENABLE_MOTU", "Enable/Disable support for the MOTU platform.", True ),
    BoolVariable( "ENABLE_DICE", "Enable/Disable support for the TCAT DICE platform.", True ),
    BoolVariable( "ENABLE_METRIC_HALO", "Enable/Disable support for the Metric Halo platform.", False ),
    BoolVariable( "ENABLE_RME", "Enable/Disable support for the RME platform.", True ),
    BoolVariable( "ENABLE_DIGIDESIGN", "Enable/Disable support for Digidesign interfaces.", False ),
    BoolVariable( "ENABLE_BOUNCE", "Enable/Disable the BOUNCE device.", False ),
    BoolVariable( "ENABLE_GENERICAVC", """\
Enable/Disable the the generic avc part (mainly used by apple).
  Note that disabling this option might be overwritten by other devices needing
  this code.""", False ),
    BoolVariable( "ENABLE_ALL", "Enable/Disable support for all devices.", False ),
    BoolVariable( "SERIALIZE_USE_EXPAT", "Use libexpat for XML serialization.", False ),
    BoolVariable( "BUILD_TESTS", """\
Build the tests in their directory. As some contain quite some functionality,
  this is on by default.
  If you just want to use ffado with jack without the tools, you can disable this.\
""", True ),
    BoolVariable( "BUILD_STATIC_TOOLS", "Build a statically linked version of the FFADO tools.", False ),
    EnumVariable('DIST_TARGET', 'Build target for cross compiling packagers', 'auto', allowed_values=('auto', 'i386', 'i686', 'x86_64', 'powerpc', 'powerpc64', 'none' ), ignorecase=2),
    BoolVariable( "ENABLE_OPTIMIZATIONS", "Enable optimizations and the use of processor specific extentions (MMX/SSE/...).", False ),
    BoolVariable( "PEDANTIC", "Enable -Werror and more pedantic options during compile.", False ),
    ( "COMPILE_FLAGS", "Add additional flags to the environment.\nOnly meant for distributors and gentoo-users who want to over-optimize their built.\n Using this is not supported by the ffado-devs!" ),
    EnumVariable( "ENABLE_SETBUFFERSIZE_API_VER", "Report API version at runtime which includes support for dynamic buffer resizing (requires recent jack).", 'auto', allowed_values=('auto', 'true', 'false', 'force'), ignorecase=2),

    )

## Load the builders in config
buildenv=os.environ

env = Environment( tools=['default','scanreplace','pyuic','pyuic4','dbus','doxygen','pkgconfig'], toolpath=['admin'], ENV = buildenv, options=opts )

if env.has_key('COMPILE_FLAGS') and len(env['COMPILE_FLAGS']) > 0:
    print '''
 * Usage of additional flags is not supported by the ffado-devs.
 * Use at own risk!
 *
 * Currentl value is '%s'
 ''' % env['COMPILE_FLAGS']
    env.MergeFlags(env['COMPILE_FLAGS'])

Help( """
For building ffado you can set different options as listed below. You have to
specify them only once, scons will save the last value you used and re-use
that.
To really undo your settings and return to the factory defaults, remove the
"cache"-folder and the file ".sconsign.dblite" from this directory.
For example with: "rm -Rf .sconsign.dblite cache"

Note that this is a development version! Don't complain if its not working!
See www.ffado.org for stable releases.
""" )
Help( opts.GenerateHelpText( env ) )

# make sure the necessary dirs exist
if not os.path.isdir( "cache" ):
	os.makedirs( "cache" )
if not os.path.isdir( 'cache/objects' ):
    os.makedirs( 'cache/objects' )

CacheDir( 'cache/objects' )

opts.Save( 'cache/options.cache', env )

def ConfigGuess( context ):
    context.Message( "Trying to find the system triple: " )
    ret = os.popen( "admin/config.guess" ).read()[:-1]
    context.Result( ret )
    return ret

def CheckForApp( context, app ):
    context.Message( "Checking whether '" + app + "' executes " )
    ret = context.TryAction( app )
    context.Result( ret[0] )
    return ret[0]

def CheckForPyModule( context, module ):
    context.Message( "Checking for the python module '" + module + "' " )
    ret = context.TryAction( "python $SOURCE", "import %s" % module, ".py" )
    context.Result( ret[0] )
    return ret[0]

def CompilerCheck( context ):
    context.Message( "Checking for a working C-compiler " )
    ret = context.TryRun( """
#include <stdio.h>

int main() {
    printf( "Hello World!" );
    return 0;
}""", '.c' )[0]
    context.Result( ret )
    if ret == 0:
        return False;
    context.Message( "Checking for a working C++-compiler " )
    ret = context.TryRun( """
#include <iostream>

int main() {
    std::cout << "Hello World!" << std::endl;
    return 0;
}""", ".cpp" )[0]
    context.Result( ret )
    return ret

def CheckPKG(context, name):
    context.Message( 'Checking for %s... ' % name )
    ret = context.TryAction('pkg-config --exists \'%s\'' % name)[0]
    context.Result( ret )
    return ret

tests = {
    "ConfigGuess" : ConfigGuess,
    "CheckForApp" : CheckForApp,
    "CheckForPyModule": CheckForPyModule,
    "CompilerCheck" : CompilerCheck,
    "CheckPKG" : CheckPKG,
}
tests.update( env['PKGCONFIG_TESTS'] )
tests.update( env['PYUIC_TESTS'] )
tests.update( env['PYUIC4_TESTS'] )

conf = Configure( env,
    custom_tests = tests,
    conf_dir = "cache/",
    log_file = 'cache/config.log' )

version_re = re.compile(r'^(\d+)\.(\d+)\.(\d+)')

def VersionInt(vers):
    match = version_re.match(vers)
    if not match:
        return -1
    (maj, min, patch) = match.group(1, 2, 3)
    # For now allow "min" to run up to 65535.  "maj" and "patch" are 
    # restricted to 0-255.
    return (int(maj) << 24) | (int(min) << 8) | int(patch)

def CheckJackdVer():
    print 'Checking jackd version...',
    ret = Popen("which jackd >/dev/null 2>&1 && jackd --version | tail -n 1 | cut -d ' ' -f 3", shell=True, stdout=PIPE).stdout.read()[:-1]
    if (ret == ""):
        print "not installed"
        return -1
    else:
        print ret
    return VersionInt(ret)

if env['SERIALIZE_USE_EXPAT']:
    env['SERIALIZE_USE_EXPAT']=1
else:
    env['SERIALIZE_USE_EXPAT']=0

if env['ENABLE_BOUNCE'] or env['ENABLE_ALL']:
    env['REQUIRE_LIBAVC']=1
else:
    env['REQUIRE_LIBAVC']=0

if not env.GetOption('clean'):
    #
    # Check for working gcc and g++ compilers and their environment.
    #
    if not conf.CompilerCheck():
        print "\nIt seems as if your system isn't even able to compile any C-/C++-programs. Probably you don't have gcc and g++ installed. Compiling a package from source without a working compiler is very hard to do, please install the needed packages.\nHint: on *ubuntu you need both gcc- and g++-packages installed, easiest solution is to install build-essential which depends on gcc and g++."
        Exit( 1 )

    # Check for pkg-config before using pkg-config to check for other dependencies.
    if not conf.CheckForPKGConfig():
        print "\nThe program 'pkg-config' could not be found.\nEither you have to install the corresponding package first or make sure that PATH points to the right directions."
        Exit( 1 )

    #
    # The following checks are for headers and libs and packages we need.
    #
    allpresent = 1;
    # for cache-serialization.
    if env['SERIALIZE_USE_EXPAT']:
        allpresent &= conf.CheckHeader( "expat.h" )
        allpresent &= conf.CheckLib( 'expat', 'XML_ExpatVersion', '#include <expat.h>' )

    pkgs = {
        'libraw1394' : '2.0.5',
        'libiec61883' : '1.1.0',
        'libconfig++' : '0'
        }

    if env['REQUIRE_LIBAVC']:
        pkgs['libavc1394'] = '0.5.3'

    if not env['SERIALIZE_USE_EXPAT']:
        pkgs['libxml++-2.6'] = '2.13.0'

    # Provide a way for users to compile newer libffado which will work 
    # against older jack installations which will not accept the new API
    # version reported at runtime.
    jackd_ver = CheckJackdVer()
    if (jackd_ver != -1):
        # If jackd is available, use the version number reported by it.  This
        # means users don't have to have jack development files present on
        # their system for this to work.
        have_jack = (jackd_ver >= VersionInt('0.0.0'))
        good_jack1 = (jackd_ver < VersionInt('1.9.0')) and (jackd_ver >= VersionInt('0.122.0'))
        good_jack2 = (jackd_ver >= VersionInt('1.9.9'))
    else:
        # Jackd is not runnable.  Attempt to identify a version from
        # pkgconfig on the off-chance jack details are available from there.
        print "Will retry jack detection using pkg-config"
        have_jack = conf.CheckPKG('jack >= 0.0.0')
        good_jack1 = conf.CheckPKG('jack < 1.9.0') and conf.CheckPKG('jack >= 0.122.0')
        good_jack2 = conf.CheckPKG('jack >= 1.9.9')
    if env['ENABLE_SETBUFFERSIZE_API_VER'] == 'auto':
        if not(have_jack):
            print """
No Jack Audio Connection Kit (JACK) installed: assuming a FFADO 
setbuffersize-compatible version will be used.
"""
        elif not(good_jack1 or good_jack2):
            FFADO_API_VERSION="8"
            print """
Installed Jack Audio Connection Kit (JACK) jack does not support FFADO 
setbuffersize API: will report earlier API version at runtime.  Consider 
upgrading to jack1 >=0.122.0 or jack2 >=1.9.9 at some point, and then 
recompile ffado to gain access to this added feature.
"""
        else:

=== debian/changelog ===
libffado (2.1.0+svn2456-1) unstable; urgency=low

  * Set architecture to linux-any (Closes: #727247)
  * Bump standards version
  * Replace python-support with dh-python
  * Imported Upstream version 2.1.0+svn2456

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Sat, 02 Nov 2013 00:27:19 +0100

=== debian/control ===
Source: libffado
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Adrian Knoth <adi@drcomp.erfurt.thur.de>,
 Free Ekanayaka <freee@debian.org>,
 Jonas Smedegaard <dr@jones.dk>
Build-Depends:
 cdbs,
 autotools-dev,
 debhelper,
 dh-buildinfo,
 dbus (>= 1.0.0),
 libconfig++-dev,
 libdbus-1-dev,
 libdbus-c++-dev,
 libdbus-c++-bin,
 libexpat1-dev,
 libiec61883-dev (>= 1.1.0),
 libraw1394-dev (>= 1.3.0),
 libxml++2.6-dev,
 libxml2-dev (>= 2.6.13),
 pkg-config,
 pyqt4-dev-tools,
 python (>= 2.6.6-3~),
 python-dbus,
 python-qt4,
 python-qt4-dbus,
 dh-python,
 scons
Standards-Version: 3.9.4
Section: libs
Homepage: http://www.ffado.org
Vcs-Git: git://git.debian.org/git/pkg-multimedia/ffado.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/ffado.git

Package: libffado-dev
Section: libdevel
Architecture: linux-any
Depends:
 libffado2 (= ${binary:Version}),
 libxml2-dev,
 ${misc:Depends},
 ${shlibs:Depends}
Description: FFADO API - development files
 FFADO is a Linux driver for FireWire (IEEE1394) audio devices.
 .
 The FFADO library permits discovering and configuring such
 devices and provides an API for streaming clients.
 .
 This package holds the development files.

Package: libffado2
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: FFADO API
 FFADO is a Linux driver for FireWire (IEEE1394) audio devices.
 .
 The FFADO library permits discovering and configuring such
 devices and provides an API for streaming clients.
 .
 This package holds the shared library.

Package: ffado-tools
Section: sound
Architecture: linux-any
Depends:
 dbus (>= 1.0.0),
 libffado2 (= ${binary:Version}),
 python,
 ${misc:Depends},
 ${shlibs:Depends}
Replaces:
 ffado-mixer-qt4 (<< 2.0.1+svn1856-2~)
Breaks:
 ffado-mixer-qt4 (<< 2.0.1+svn1856-2~),
 jackd1-firewire (<< 1:0.121.3+20120418git75e3e20b-1),
 jackd2-firewire (<< 1.9.8~dfsg.3+20120418gitf82ec715-1)
Description: FFADO debugging and firmware tools
 FFADO is a Linux driver for FireWire (IEEE1394) audio devices.
 .
 The FFADO library permits discovering and configuring such
 devices and provides an API for streaming clients.
 .
 This package holds the following tools for firmware updating,
 troubleshooting and debugging:
     * ffado-test-streaming
     * ffado-diag
     * ffado-test-isoxmit
     * ffado-test-isorecv
     * ffado-bridgeco-downloader
     * ffado-test
     * ffado-fireworks-downloader

Package: ffado-dbus-server
Section: sound
Architecture: linux-any
Depends:
 dbus (>= 1.0.0),
 libffado2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: FFADO D-Bus server
 FFADO is a Linux driver for FireWire (IEEE1394) audio devices.
 .
 The FFADO library permits discovering and configuring such
 devices and provides an API for streaming clients.
 .
 This package holds the D-Bus server that exposes the mixer
 and control interfaces through D-Bus.

Package: ffado-mixer-qt4
Section: sound
Architecture: all
Depends:
 ffado-dbus-server (>= ${source:Version}),
 ffado-tools (>= ${source:Version}),
 python,
 python-dbus,
 python-qt4,
 python-qt4-dbus,
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends}
Description: FFADO D-Bus mixer applets (QT4)
 FFADO is a Linux driver for FireWire (IEEE1394) audio devices.
 .
 The FFADO library permits discovering and configuring such
 devices and provides an API for streaming clients.
 .
 This package holds the mixer and control applications that
 communicate with ffado-dbus-server. (Qt4 version)

## libffado 2.2.1

=== SConstruct ===
--- 
+++ 
@@ -1,4 +1,3 @@
-#! /usr/bin/python
 # -*- coding: utf-8 -*-
 #
 # Copyright (C) 2007, 2008, 2010 Arnold Krille
@@ -25,7 +24,7 @@
 #
 
 FFADO_API_VERSION = "9"
-FFADO_VERSION="2.1.9999"
+FFADO_VERSION="2.2.1"
 
 from subprocess import Popen, PIPE
 import os
@@ -41,9 +40,10 @@
 
 opts.AddVariables(
     BoolVariable( "DEBUG", """\
-Toggle debug-build. DEBUG means \"-g -Wall\" and more, otherwise we will use
-  \"-O2\" to optimize.""", True ),
-    BoolVariable( "PROFILE", "Build with symbols and other profiling info", False ),
+Build with \"-g -Wall\" rather than \"-O2\", and include extra debugging
+checks in the code.""", True ),
+    BoolVariable( "DEBUG_MESSAGES", "Enable support for debug messages", True ),
+    BoolVariable( "PROFILE", "Build with symbols, warnings and other profiling info", False ),
     PathVariable( "PREFIX", "The prefix where ffado will be installed to.", "/usr/local", PathVariable.PathAccept ),
     PathVariable( "BINDIR", "Overwrite the directory where apps are installed to.", "$PREFIX/bin", PathVariable.PathAccept ),
     PathVariable( "LIBDIR", "Overwrite the directory where libs are installed to.", "$PREFIX/lib", PathVariable.PathAccept ),
@@ -121,7 +121,7 @@
 
 def ConfigGuess( context ):
     context.Message( "Trying to find the system triple: " )
-    ret = os.popen( "admin/config.guess" ).read()[:-1]
+    ret = os.popen( "/bin/sh admin/config.guess" ).read()[:-1]
     context.Result( ret )
     return ret
 
@@ -256,7 +256,7 @@
         # means users don't have to have jack development files present on
         # their system for this to work.
         have_jack = (jackd_ver >= VersionInt('0.0.0'))
-        good_jack1 = (jackd_ver < VersionInt('1.9.0')) and (jackd_ver >= VersionInt('0.122.0'))
+        good_jack1 = (jackd_ver < VersionInt('1.9.0')) and (jackd_ver >= VersionInt('0.121.4'))
         good_jack2 = (jackd_ver >= VersionInt('1.9.9'))
     else:
         # Jackd is not runnable.  Attempt to identify a version from
@@ -277,6 +277,3 @@
 Installed Jack Audio Connection Kit (JACK) jack does not support FFADO 
 setbuffersize API: will report earlier API version at runtime.  Consider 
 upgrading to jack1 >=0.122.0 or jack2 >=1.9.9 at some point, and then 
-recompile ffado to gain access to this added feature.
-"""
-        else:

=== debian/changelog ===
libffado (2.2.1-3) unstable; urgency=medium

  [ Jonas Smedegaard ]
  * Add watch file.
  * Declare compliance with Standards-Version 3.9.6.
  * Fix add trailing / to Homepage URL.
  * Update Vcs-Browser field to use new canonical https-based cgit URL.
  * Update Vcs-Git to skip optional /git from path.
  * Modernize CDBS usage: Stop suppress optional build-dependencies: All
    satisfied even in oldstable nowadays.
    Build-depend on devscripts.

  [ David Matthew Mattli ]
  * Fix FTBFS due to re-definition of errno in tests. (Closes: #805211)

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Dec 2015 00:54:26 +0000

libffado (2.2.1-2) unstable; urgency=medium

  * Team upload.
  * debian/patches/cpuinfo-parsing.patch: Fix /proc/cpuinfo parsing. Thanks to
    Plamen Aleksandrov. (Closes: #751228)

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 07 Jul 2014 18:38:48 +0200

libffado (2.2.1-1) unstable; urgency=low

  * Imported Upstream version 2.2.1
  * Bump standards version

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Mon, 02 Jun 2014 13:17:09 +0000

=== debian/control ===
--- 
+++ 
@@ -10,6 +10,7 @@
  autotools-dev,
  debhelper,
  dh-buildinfo,
+ devscripts,
  dbus (>= 1.0.0),
  libconfig++-dev,
  libdbus-1-dev,
@@ -28,11 +29,11 @@
  python-qt4-dbus,
  dh-python,
  scons
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 Section: libs
-Homepage: http://www.ffado.org
-Vcs-Git: git://git.debian.org/git/pkg-multimedia/ffado.git
-Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/ffado.git
+Homepage: http://www.ffado.org/
+Vcs-Git: git://git.debian.org/pkg-multimedia/ffado.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/ffado.git
 
 Package: libffado-dev
 Section: libdevel

=== debian/rules ===
#!/usr/bin/make -f
#
# Pieter Palmers <pieter.palmers@ffado.org>
#
# Robert Jordens <jordens@debian.org>
#
# This software may be used and distributed according to the terms
# of the GNU General Public License, incorporated herein by reference.
#

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/utils.mk

DEB_CLEAN_EXCLUDE=debian/tmp

DEB_PYTHON2_MODULE_PACKAGES := ffado-tools ffado-mixer-qt4

### Add a soname ###

DEBIAN_FFADO_COMPATIBLE_VERSION = 2.0

CFLAGS += "-fPIC"

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NJOBS += -j$(NUMJOBS)
endif

ifneq (,$(findstring power,$(DEB_BUILD_ARCH)))
EXPLICIT_TARGET = DIST_TARGET=powerpc
else ifneq (,$(findstring i386,$(DEB_BUILD_ARCH)))
EXPLICIT_TARGET = DIST_TARGET=i386
else
EXPLICIT_TARGET =
endif

DEB_SCONS_EXTRA_FLAGS := \
	PREFIX=/usr \
	SHAREDIR=/usr/share/libffado2/ \
	PYPKGDIR=/usr/share/ffado-mixer-qt4/ \
	WILL_DEAL_WITH_XDG_MYSELF=1 \
	$(EXPLICIT_TARGET) \
	$(NJOBS)


DEB_SCONS_NOOPT_FLAGS := ENABLE_OPTIMIZATION=no

DEB_DH_MAKESHLIBS_ARGS := --version-info="libffado2 (>=${DEBIAN_FFADO_COMPATIBLE_VERSION})"

DEB_SCONS_ENVVARS :=
DEB_SCONS_INVOKE = $(DEB_SCONS_ENVVARS) scons 

DEB_SCONS_ARGS_COMMON = 'COMPILE_FLAGS=$(CFLAGS)' $(DEB_SCONS_EXTRA_FLAGS) \
				$(DEB_SCONS_NOOPT_FLAGS)

DEB_SCONS_ARGS_NODBG = $(DEB_SCONS_ARGS_COMMON) DESTDIR=$(DEB_DESTDIR) DEBUG=0
DEB_SCONS_ARGS_DBG = $(DEB_SCONS_ARGS_COMMON) DESTDIR=$(DEB_DESTDIR)/dbg DEBUG=1

#common-build-arch:: debian/stamp-scons-build
### Mangle libffado filename ###
debian/stamp-scons-build:
	-mkdir -p $(DEB_DESTDIR)
	$(DEB_SCONS_INVOKE) $(DEB_SCONS_ARGS_NODBG)
	$(DEB_SCONS_INVOKE) $(DEB_SCONS_ARGS_NODBG) install
	$(DEB_SCONS_INVOKE) $(DEB_SCONS_ARGS_DBG)
	$(DEB_SCONS_INVOKE) $(DEB_SCONS_ARGS_DBG) install
	touch debian/stamp-scons-build

# this is bad but the only easy way to have ardour.rc generated from
# ardour.rc.in
common-install-indep:: debian/stamp-scons-build
common-install-arch:: debian/stamp-scons-build

clean:: scons-clean
scons-clean::
	$(MAKE) -f debian/rules reverse-config
	-mkdir -p $(DEB_DESTDIR)
	-$(DEB_SCONS_INVOKE) --clean
	-rm -rf $(DEB_DESTDIR) debian/stamp-scons-build
	-rm -rf config.log scache.conf .sconf_temp .sconsign.dblite cache
	-rm -rf admin/*.pyc

binary-install/ffado-mixer-qt4::
	dh_python2 -pffado-mixer-qt4

binary-install/ffado-tools::
	dh_python2 -pffado-tools

=== debian/watch ===
# Run the "uscan" command to check for upstream updates and more.
version=3
http://www.ffado.org/ files/libffado-(\d[\d+\.]+)\.tgz

## libffado 2.3.0

=== SConstruct ===
--- 
+++ 
@@ -24,7 +24,7 @@
 #
 
 FFADO_API_VERSION = "9"
-FFADO_VERSION="2.2.1"
+FFADO_VERSION="2.3.0"
 
 from subprocess import Popen, PIPE
 import os
@@ -68,6 +68,7 @@
   this code.""", False ),
     BoolVariable( "ENABLE_ALL", "Enable/Disable support for all devices.", False ),
     BoolVariable( "SERIALIZE_USE_EXPAT", "Use libexpat for XML serialization.", False ),
+    EnumVariable( "BUILD_MIXER", "Build the ffado-mixer", 'auto', allowed_values=('auto', 'true', 'false'), ignorecase=2),
     BoolVariable( "BUILD_TESTS", """\
 Build the tests in their directory. As some contain quite some functionality,
   this is on by default.
@@ -76,8 +77,10 @@
     BoolVariable( "BUILD_STATIC_TOOLS", "Build a statically linked version of the FFADO tools.", False ),
     EnumVariable('DIST_TARGET', 'Build target for cross compiling packagers', 'auto', allowed_values=('auto', 'i386', 'i686', 'x86_64', 'powerpc', 'powerpc64', 'none' ), ignorecase=2),
     BoolVariable( "ENABLE_OPTIMIZATIONS", "Enable optimizations and the use of processor specific extentions (MMX/SSE/...).", False ),
+    BoolVariable( "DETECT_USERSPACE_ENV", "Try to detect the user space environment and add necessary 32/64 bit machine flags.", True ),
     BoolVariable( "PEDANTIC", "Enable -Werror and more pedantic options during compile.", False ),
-    ( "COMPILE_FLAGS", "Add additional flags to the environment.\nOnly meant for distributors and gentoo-users who want to over-optimize their built.\n Using this is not supported by the ffado-devs!" ),
+    BoolVariable( "CUSTOM_ENV", "Respect CC, CXX, CFLAGS, CXXFLAGS and LDFLAGS.\nOnly meant for distributors and gentoo-users who want to over-optimize their build.\n Using this is not supported by the ffado-devs!", False ),
+    ( "COMPILE_FLAGS", "Deprecated (use CFLAGS and CXXFLAGS with CUSTOM_ENV=True instead).  Add additional flags to the environment.\nOnly meant for distributors and gentoo-users who want to over-optimize their build.\n Using this is not supported by the ffado-devs!" ),
     EnumVariable( "ENABLE_SETBUFFERSIZE_API_VER", "Report API version at runtime which includes support for dynamic buffer resizing (requires recent jack).", 'auto', allowed_values=('auto', 'true', 'false', 'force'), ignorecase=2),
 
     )
@@ -87,14 +90,42 @@
 
 env = Environment( tools=['default','scanreplace','pyuic','pyuic4','dbus','doxygen','pkgconfig'], toolpath=['admin'], ENV = buildenv, options=opts )
 
+custom_flags = False
+
 if env.has_key('COMPILE_FLAGS') and len(env['COMPILE_FLAGS']) > 0:
+    print "The COMPILE_FLAGS option is deprecated. Use CFLAGS and CXXFLAGS with CUSTOM_ENV=True instead"
+    custom_flags = True
+    env.MergeFlags(env['COMPILE_FLAGS'])
+
+if env['CUSTOM_ENV']:
+    custom_flags = True
+
+    # Honour the user choice of compiler (if any).
+    if os.environ.has_key('CC') and len(os.environ['CC']) > 0:
+        env['CC'] = os.environ['CC']
+    if os.environ.has_key('CXX') and len(os.environ['CXX']) > 0:
+        env['CXX'] = os.environ['CXX']
+
+    # Honour the user supplied flags (if any), but notify the user that this is not supported.
+    if os.environ.has_key('CFLAGS') and len(os.environ['CFLAGS']) > 0:
+        env.Append(CFLAGS = str(os.environ['CFLAGS'].replace('\"', '')))
+    if os.environ.has_key('CXXFLAGS') and len(os.environ['CXXFLAGS']) > 0:
+        env.Append(CXXFLAGS = str(os.environ['CXXFLAGS'].replace('\"', '')))
+    if os.environ.has_key('LDFLAGS') and len(os.environ['LDFLAGS']) > 0:
+        env.Append(LINKFLAGS = str(os.environ['LDFLAGS'].replace('\"', '')))
+
+if custom_flags:
     print '''
  * Usage of additional flags is not supported by the ffado-devs.
  * Use at own risk!
  *
- * Currentl value is '%s'
- ''' % env['COMPILE_FLAGS']
-    env.MergeFlags(env['COMPILE_FLAGS'])
+ * Flags in use:
+ *   CC = %s
+ *   CXX = %s
+ *   CFLAGS = %s
+ *   CXXFLAGS = %s
+ *   LDFLAGS = %s
+''' % (env['CC'], env['CXX'], env['CFLAGS'], env['CXXFLAGS'], env['LINKFLAGS'])
 
 Help( """
 For building ffado you can set different options as listed below. You have to
@@ -242,38 +273,3 @@
         }
 
     if env['REQUIRE_LIBAVC']:
-        pkgs['libavc1394'] = '0.5.3'
-
-    if not env['SERIALIZE_USE_EXPAT']:
-        pkgs['libxml++-2.6'] = '2.13.0'
-
-    # Provide a way for users to compile newer libffado which will work 
-    # against older jack installations which will not accept the new API
-    # version reported at runtime.
-    jackd_ver = CheckJackdVer()
-    if (jackd_ver != -1):
-        # If jackd is available, use the version number reported by it.  This
-        # means users don't have to have jack development files present on
-        # their system for this to work.
-        have_jack = (jackd_ver >= VersionInt('0.0.0'))
-        good_jack1 = (jackd_ver < VersionInt('1.9.0')) and (jackd_ver >= VersionInt('0.121.4'))
-        good_jack2 = (jackd_ver >= VersionInt('1.9.9'))
-    else:
-        # Jackd is not runnable.  Attempt to identify a version from
-        # pkgconfig on the off-chance jack details are available from there.
-        print "Will retry jack detection using pkg-config"
-        have_jack = conf.CheckPKG('jack >= 0.0.0')
-        good_jack1 = conf.CheckPKG('jack < 1.9.0') and conf.CheckPKG('jack >= 0.122.0')
-        good_jack2 = conf.CheckPKG('jack >= 1.9.9')
-    if env['ENABLE_SETBUFFERSIZE_API_VER'] == 'auto':
-        if not(have_jack):
-            print """
-No Jack Audio Connection Kit (JACK) installed: assuming a FFADO 
-setbuffersize-compatible version will be used.
-"""
-        elif not(good_jack1 or good_jack2):
-            FFADO_API_VERSION="8"
-            print """
-Installed Jack Audio Connection Kit (JACK) jack does not support FFADO 
-setbuffersize API: will report earlier API version at runtime.  Consider 
-upgrading to jack1 >=0.122.0 or jack2 >=1.9.9 at some point, and then

=== debian/changelog ===
libffado (2.3.0-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add upstream fix for FTBFS with glibc 2.26,
    thanks to Juhani Numminen. (Closes: #887781)

 -- Adrian Bunk <bunk@debian.org>  Tue, 06 Feb 2018 21:14:14 +0200

libffado (2.3.0-5) unstable; urgency=medium

  * Team upload.
  * debian/rules: drop code specifying DIST_TARGET to the build system.
    Disabling all automation seems to let the compiler do the right thing
    better than this stuff.

 -- Mattia Rizzolo <mattia@debian.org>  Sun, 12 Nov 2017 11:55:33 +0100

libffado (2.3.0-4) unstable; urgency=medium

  * Team upload.
  * debian/rules: set DETECT_USERSPACE_ENV=0 to avoid having the build system
    unhelpfully pass -m flags to gcc.
    It breaks builds in mismatched userspace/kernel setups (i.e. i386 chroot
    with amd64 kernel) and with architectures that the poor recognizing
    script fail with (i.e. ppc64).

 -- Mattia Rizzolo <mattia@debian.org>  Sat, 11 Nov 2017 15:28:49 +0100

libffado (2.3.0-3) unstable; urgency=medium

  * Team upload.
  * Add patches to fix the build with GCC 7.  Closes: #853491
  * debian/rules:
    + Really make this package reproducible.  Closes: #828060
    + Fixup some host/build architecture confusion.
  * Bump debhelper compat level to 10
  * Multiarchify the library installation:
    * Move all library files to a triplet-defined directory /usr/lib/<trplet>/.
    * Change ffado-debug to load from that directory.
  * debian/control:
    + Use canonical URL in Vcs-* fields.
    + Drop dh-buildinfo build-dep.
    + Drop unused build-dep autotools-dev and devscripts.
    + Mark libffado-dev and libffado2 as multi-arch:same.
  * Move the ffado-debug binary from libffado2 to the ffado-tools package.

 -- Mattia Rizzolo <mattia@debian.org>  Sat, 11 Nov 2017 01:12:03 +0100

libffado (2.3.0-2) unstable; urgency=medium

  * Make FFADO builds reproducible (Closes: #828060)
  * Fix FTBFS on PowerPCspe (Closes: #772937)

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Fri, 12 Aug 2016 10:47:17 +0200

libffado (2.3.0-1) unstable; urgency=low

  [ Jonas Smedegaard ]
  * Add watch file.
  * Declare compliance with Standards-Version 3.9.6.
  * Fix add trailing / to Homepage URL.
  * Update Vcs-Browser field to use new canonical https-based cgit URL.
  * Update Vcs-Git to skip optional /git from path.
  * Modernize CDBS usage: Stop suppress optional build-dependencies: All
    satisfied even in oldstable nowadays.
    Build-depend on devscripts.

  [ Alessio Treglia ]
  * Fix FTBFS on x32.
    Thanks to Thorsten Glaser for the patch (Closes: #778777)

  [ Adrian Knoth ]
  * Imported Upstream version 2.3.0 (Closes: #833949)
  * Add gcc6.patch

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Thu, 11 Aug 2016 16:03:34 +0200

=== debian/control ===
--- 
+++ 
@@ -4,18 +4,17 @@
 Uploaders:
  Adrian Knoth <adi@drcomp.erfurt.thur.de>,
  Free Ekanayaka <freee@debian.org>,
- Jonas Smedegaard <dr@jones.dk>
+ Jonas Smedegaard <dr@jones.dk>,
 Build-Depends:
  cdbs,
- autotools-dev,
- debhelper,
- dh-buildinfo,
- devscripts,
  dbus (>= 1.0.0),
+ debhelper (>= 10),
+ dh-exec,
+ dh-python,
  libconfig++-dev,
  libdbus-1-dev,
+ libdbus-c++-bin,
  libdbus-c++-dev,
- libdbus-c++-bin,
  libexpat1-dev,
  libiec61883-dev (>= 1.1.0),
  libraw1394-dev (>= 1.3.0),
@@ -27,22 +26,22 @@
  python-dbus,
  python-qt4,
  python-qt4-dbus,
- dh-python,
- scons
-Standards-Version: 3.9.6
+ scons,
+Standards-Version: 3.9.8
 Section: libs
 Homepage: http://www.ffado.org/
-Vcs-Git: git://git.debian.org/pkg-multimedia/ffado.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/ffado.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/ffado.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-multimedia/ffado.git
 
 Package: libffado-dev
 Section: libdevel
 Architecture: linux-any
+Multi-Arch: same
 Depends:
  libffado2 (= ${binary:Version}),
  libxml2-dev,
  ${misc:Depends},
- ${shlibs:Depends}
+ ${shlibs:Depends},
 Description: FFADO API - development files
  FFADO is a Linux driver for FireWire (IEEE1394) audio devices.
  .
@@ -53,9 +52,10 @@
 
 Package: libffado2
 Architecture: linux-any
+Multi-Arch: same
 Depends:
  ${misc:Depends},
- ${shlibs:Depends}
+ ${shlibs:Depends},
 Description: FFADO API
  FFADO is a Linux driver for FireWire (IEEE1394) audio devices.
  .
@@ -72,13 +72,15 @@
  libffado2 (= ${binary:Version}),
  python,
  ${misc:Depends},
- ${shlibs:Depends}
+ ${shlibs:Depends},
 Replaces:
- ffado-mixer-qt4 (<< 2.0.1+svn1856-2~)
+ ffado-mixer-qt4 (<< 2.0.1+svn1856-2~),
+ libffado2 (<< 2.3.0-3),
 Breaks:
  ffado-mixer-qt4 (<< 2.0.1+svn1856-2~),
  jackd1-firewire (<< 1:0.121.3+20120418git75e3e20b-1),
- jackd2-firewire (<< 1.9.8~dfsg.3+20120418gitf82ec715-1)
+ jackd2-firewire (<< 1.9.8~dfsg.3+20120418gitf82ec715-1),
+ libffado2 (<< 2.3.0-3),
 Description: FFADO debugging and firmware tools
  FFADO is a Linux driver for FireWire (IEEE1394) audio devices.
  .
@@ -94,6 +96,7 @@
      * ffado-bridgeco-downloader
      * ffado-test
      * ffado-fireworks-downloader
+     * ffado-debug
 
 Package: ffado-dbus-server
 Section: sound
@@ -102,7 +105,7 @@
  dbus (>= 1.0.0),
  libffado2 (= ${binary:Version}),
  ${misc:Depends},
- ${shlibs:Depends}
+ ${shlibs:Depends},
 Description: FFADO D-Bus server
  FFADO is a Linux driver for FireWire (IEEE1394) audio devices.
  .
@@ -124,7 +127,7 @@
  python-qt4-dbus,
  ${misc:Depends},
  ${python:Depends},
- ${shlibs:Depends}
+ ${shlibs:Depends},
 Description: FFADO D-Bus mixer applets (QT4)
  FFADO is a Linux driver for FireWire (IEEE1394) audio devices.
  .

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,7 @@
 # of the GNU General Public License, incorporated herein by reference.
 #
 
+include /usr/share/dpkg/architecture.mk
 include /usr/share/cdbs/1/rules/debhelper.mk
 include /usr/share/cdbs/1/rules/utils.mk
 
@@ -26,20 +27,13 @@
   NJOBS += -j$(NUMJOBS)
 endif
 
-ifneq (,$(findstring power,$(DEB_BUILD_ARCH)))
-EXPLICIT_TARGET = DIST_TARGET=powerpc
-else ifneq (,$(findstring i386,$(DEB_BUILD_ARCH)))
-EXPLICIT_TARGET = DIST_TARGET=i386
-else
-EXPLICIT_TARGET =
-endif
-
 DEB_SCONS_EXTRA_FLAGS := \
 	PREFIX=/usr \
+	LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
 	SHAREDIR=/usr/share/libffado2/ \
 	PYPKGDIR=/usr/share/ffado-mixer-qt4/ \
 	WILL_DEAL_WITH_XDG_MYSELF=1 \
-	$(EXPLICIT_TARGET) \
+	DETECT_USERSPACE_ENV=0 \
 	$(NJOBS)
 
 
@@ -84,4 +78,6 @@
 	dh_python2 -pffado-mixer-qt4
 
 binary-install/ffado-tools::
+	sed -i 's/@@MULTIARCH@@/$(DEB_HOST_MULTIARCH)/' debian/ffado-tools/usr/bin/ffado-debug
+	find debian/ffado-tools -type f -name "static_info.txt" -delete
 	dh_python2 -pffado-tools
